class Amount {
  final int amount;
  final String currency;

  Amount(this.amount, this.currency);
  Amount.named({this.amount, this.currency});

  Amount copyWith({int amount, String currency}) {
    return Amount.named(
        amount: amount ?? this.amount, currency: currency ?? this.currency);
  }

  operator +(Amount other) {
    assert(other.currency.toLowerCase() == currency.toLowerCase());
    return Amount.named(
        amount: (amount ?? 0) + other.amount, currency: currency);
  }
}
