import 'package:json_annotation/json_annotation.dart';
import 'package:ocg_payment/src/modals/client.dart';

part 'request.g.dart';

@JsonSerializable(explicitToJson: true)
class PaymentRequest {
  final String id;
  final int amount;
  final int taxes;
  final String currency;
  final PaymentClient client;
  final String methodId;

  PaymentRequest(this.id, this.amount, this.taxes, this.currency, this.client,
      this.methodId);

  PaymentRequest.named(
      {this.id,
      this.amount,
      this.taxes,
      this.currency,
      this.client,
      this.methodId});

  PaymentRequest copyWith(
          {String id,
          int amount,
          int taxes,
          String currency,
          PaymentClient client,
          String methodId}) =>
      PaymentRequest.named(
        id: id ?? this.id,
        currency: currency ?? this.currency,
        amount: amount ?? this.amount,
        client: client ?? this.client,
        methodId: methodId ?? this.methodId,
      );

  Map<String, dynamic> toJson() => _$PaymentRequestToJson(this);

  factory PaymentRequest.fromJson(json) => _$PaymentRequestFromJson(json);
}
